package aexp.instrcontroller;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;

public class Instrcontroller 
                extends Activity {
    static final String LOG_TAG = "Instrcontroller";
    TestResultBroadcastReceiver trb = new TestResultBroadcastReceiver();
    TextView resultText;
    TextView testresultText;
    TextView testmessageText;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.launcher);
        IntentFilter intentFilter = new IntentFilter( "TESTRESULT" );
        intentFilter.addCategory( "CALCULATOR_TEST_RESULT" );
        registerReceiver( trb,intentFilter );
        Button launcherButton = (Button)findViewById( R.id.launch_button );
        resultText = (TextView)findViewById( R.id.result_text );
        testresultText = (TextView)findViewById( R.id.testresult_text );
        testmessageText = (TextView)findViewById( R.id.testmessage_text );
        launcherButton.setOnClickListener( new View.OnClickListener() {
            public void onClick( View view ) {
                startInstrumentation(
                    new ComponentName( 
                        "aexp.instrumentation",
                        "aexp.instrumentation.CalculatorInstrumentation" ), 
                    null, 
                    null );
            }
        } );
    }

    @Override
    public void onDestroy() {
        unregisterReceiver( trb );
    }

    public void onActivityResult(int requestCode, int resultCode, Intent data)  {
        super.onActivityResult( requestCode, resultCode, data );
        Log.d( LOG_TAG, "onActivityResult: "+data.getExtras() );
    }

    class TestResultBroadcastReceiver extends BroadcastReceiver {
        public void onReceive(Context context, Intent intent) {
            Log.d( LOG_TAG, "onReceive: "+intent );
            Bundle b = intent.getExtras();
            if( b != null ) {
                String testName = b.getString( "testname" );
                boolean testResult = b.getBoolean( "testResult" );
                String message = b.getString( "message" );
                String result = b.getString( "result" );
                Log.d( LOG_TAG, "testName: "+testName+
                        "; testResult: "+testResult+
                        "; result: "+result+
                        "; message: "+message );
                String msg = testName + 
                                ": " + 
                                ( testResult ? "Success" : "Failure" );
                resultText.setText( msg );
                testresultText.setText( result );
                testmessageText.setText( message );
            }
        }
    }

}
